var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
/**
 * IMPORTANT: Changes in this file MUST be duplicated in edge-react-gui!
 */
import * as React from 'react';
import { FlatList, Keyboard } from 'react-native';
import { useFilter } from '../../hooks/useFilter';
import { useTheme } from '../services/ThemeContext';
import { ModalFooter, ModalMessage, ModalTitle } from '../themed/ModalParts';
import { OutlinedTextInput } from '../themed/OutlinedTextInput';
import { ThemedModal } from '../themed/ThemedModal';
export function ListModal(_a) {
    var { bridge, title, message, hideSearch = false, initialValue = '', rowsData = [], fullScreen = true, rowComponent, rowDataFilter, closeArrow = true, onSubmitEditing, onViewableItemsChanged } = _a, textProps = __rest(_a, ["bridge", "title", "message", "hideSearch", "initialValue", "rowsData", "fullScreen", "rowComponent", "rowDataFilter", "closeArrow", "onSubmitEditing", "onViewableItemsChanged"]);
    const theme = useTheme();
    const [text, setText] = React.useState(initialValue);
    const [filteredRows, setFilteredRows] = useFilter(rowsData, rowDataFilter);
    const renderItem = ({ item }) => rowComponent ? rowComponent(item) : null;
    const handleCancel = () => bridge.resolve(undefined);
    const handleChangeText = (text) => {
        setText(text);
        setFilteredRows(text);
    };
    const handleSubmitEditing = () => onSubmitEditing != null ? onSubmitEditing(text) : bridge.resolve(text);
    const scrollPadding = React.useMemo(() => {
        return { paddingBottom: theme.rem(ModalFooter.bottomRem) };
    }, [theme]);
    return (React.createElement(ThemedModal, { bridge: bridge, closeButton: closeArrow, onCancel: handleCancel },
        title == null ? null : React.createElement(ModalTitle, null, title),
        message == null ? null : React.createElement(ModalMessage, null, message),
        hideSearch ? null : (React.createElement(OutlinedTextInput
        // Our props:
        , Object.assign({ 
            // Our props:
            searchIcon: true, blurOnClear: true, autoCorrect: false, autoCapitalize: "words", returnKeyType: "done", marginRem: [1, 0.5], testID: title, onChangeText: handleChangeText, onSubmitEditing: handleSubmitEditing, value: text }, textProps))),
        React.createElement(FlatList, { contentContainerStyle: scrollPadding, data: filteredRows, keyboardShouldPersistTaps: "handled", keyExtractor: (_, i) => `${i}`, renderItem: renderItem, onScroll: () => Keyboard.dismiss(), onViewableItemsChanged: onViewableItemsChanged })));
}
