/**
 * IMPORTANT: Changes in this file MUST be duplicated in edge-react-gui!
 */
import * as React from 'react';
import { StyleSheet } from 'react-native';
import { AirshipModal } from 'react-native-airship';
import { BlurView } from 'rn-id-blurview';
import { fixSides } from '../../util/sides';
import { useTheme } from '../services/ThemeContext';
import { ModalFooter, ModalScrollArea } from './ModalParts';
/**
 * The Airship modal, but connected to our theming system.
 */
export function ThemedModal(props) {
    const { bridge, closeButton = true, children, flexDirection, justifyContent, warning = false, scroll = false, onCancel } = props;
    const paddingRem = fixSides(props.paddingRem, 1);
    const theme = useTheme();
    // TODO: The warning styles are incorrectly hard-coded:
    const borderColor = warning ? theme.warningText : theme.modalBorderColor;
    const borderWidth = warning ? 4 : theme.modalBorderWidth;
    return (React.createElement(AirshipModal, { bridge: bridge, backgroundColor: theme.modal, borderRadius: theme.rem(theme.modalBorderRadiusRem), borderColor: borderColor, borderWidth: borderWidth, flexDirection: flexDirection, justifyContent: justifyContent, onCancel: onCancel, padding: paddingRem.map(theme.rem), underlay: React.createElement(BlurView, { blurType: theme.isDark ? 'light' : 'dark', style: StyleSheet.absoluteFill }) },
        React.createElement(React.Fragment, null,
            scroll ? React.createElement(ModalScrollArea, null, children) : children,
            closeButton ? React.createElement(ModalFooter, { onPress: onCancel }) : null)));
}
